<template>
  <!-- 查询和其他操作 -->
  <div class="filter-container" style="margin: 10px 0 10px 0;">
    <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
      <el-form-item label="用户来源">
        <el-select
          v-model="queryParams.source"
          class="filter-item"
          placeholder="用户来源"
          style="width: 140px"
          filterable
          clearable
          remote
          reserve-keyword
        >
          <el-option
            v-for="item in sourceData"
            :key="item.source"
            :label="item.name"
            :value="item.source"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="用户ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.openId" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="瓦力ID">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.uid" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="会员状态">
        <el-select v-model="queryParams.isVip" placeholder="会员状态"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value=""></el-option>
          <el-option label="会员" value="1">会员</el-option>
          <el-option label="非会员" value="0">非会员</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="订单号">
        <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.requestId" placeholder="请输入" />
      </el-form-item>
      <el-form-item label="订单状态">
        <el-select v-model="queryParams.orderStatus" placeholder="订单状态"  class="filter-item" style="width: 200px;">
          <el-option label="全选" value=""></el-option>
          <el-option label="待审批" value="0">待审批</el-option>
          <el-option label="审批通过" value="1">审批通过</el-option>
          <el-option label="完成付款" value="2">完成付款</el-option>
          <el-option label="审批拒绝" value="3">审批拒绝</el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="日期时间">
        <el-date-picker
          v-model="queryParams.beginCreateTime"
          type="datetime"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endCreateTime"
          type="datetime"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label-width="auto" label="状态异动时间">
        <el-date-picker
          v-model="queryParams.beginUpdateTime"
          type="datetime"
          placeholder="开始日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
        <span> - </span>
        <el-date-picker
          v-model="queryParams.endUpdateTime"
          type="datetime"
          placeholder="结束日期"
          class="baseInput"
          format="yyyy-MM-dd HH"
          value-format="yyyy-MM-dd HH"
          style="width: 200px;"
        >
        </el-date-picker>
      </el-form-item>

      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">筛选</el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-s-flag" @click="exportData">导出</el-button>
    </el-form>

    <div style="margin: 10px 10px 10px 10px;">
      <span>提现总金额:</span>
      <el-input type="number"  style="width: 150px;"  v-model="sumAmount"  readonly="readonly"/>
      <span>提现用户总数:</span>
      <el-input type="number"  style="width: 100px;"  v-model="totalTimes" readonly="readonly"/>
    </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >
      <el-table-column label="提现订单号" style="width:10%" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.requestId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="提现申请时间" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.openId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="瓦力ID" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.cusUid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="会员状态" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.isVip == 1">会员</span>
          <span v-if="scope.row.isVip == 0 || scope.row.isVip == ''">非会员</span>
        </template>
      </el-table-column>
      <el-table-column label="用户来源" style="width:15%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户昵称" style="width:10%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.loginName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="提现金额" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.amount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="提现金额(已扣手续费)" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.taxAmount }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作人员" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>admin</span>
        </template>
      </el-table-column>
      <el-table-column label="状态异动时间" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.updateTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" style="width:5%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.flag == 0">待审批</span>
          <span v-if="scope.row.flag == 1">审批通过</span>
          <span v-if="scope.row.flag == 2">完成付款</span>
          <span v-if="scope.row.flag == 3">审批拒绝</span>
        </template>
      </el-table-column>
<!--      <el-table-column label="备注" style="width:6%" :show-overflow-tooltip="true" align="center">-->
<!--        <template slot-scope="scope">-->
<!--          <span>{{ scope.row.remark }}</span>-->
<!--        </template>-->
<!--      </el-table-column>-->
      <el-table-column label="拒绝理由" style="width:6%" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.remarks }}</span>
        </template>
      </el-table-column>
      <el-table-column  label="操作" fixed="right" style="width:3%">
        <template slot-scope="scope" >
<!--          <el-button  @click="handleAdd(scope.row)" type="primary" size="small">新增</el-button>-->
          <el-button v-if="scope.row.flag == 3" @click="handleEdit(scope.row)" type="primary" size="small">编辑备注</el-button>
        </template>
      </el-table-column>

    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>


    <el-dialog :title="title"  :close-on-click-modal="false" :visible.sync="dialogFormVisible" width="30%" :before-close="sortHandleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="备注" :label-width="formLabelWidth" prop="remarks">
          <el-input type="textarea" v-model="form.remarks"  auto-complete="new-password" style="width:80%" maxlength="100" show-word-limit :autosize="{ minRows: 5, maxRows: 5 }"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="sortHandleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
  import {dateFormat} from "@/utils/webUtils.js";
  import {getWithdrawalList,getWithdrawalTotal,editWithdrawalInfo,getSourceList} from "@/api/withdrawalRequest";
  import {
    export_json_to_excel
  } from "@/vendor/Export2Excel";

  export default {
    data() {
      return {
        sourceData: [
          {
            name:'全选',
            source:''}
        ],
        queryParams:{//查询参数
          requestId: "",//订单ID
          openId: "", //用户ID
          beginCreateTime: dateFormat("YYYY-mm-dd 00", new Date()), //创建时间-开始
          endCreateTime: dateFormat("YYYY-mm-dd 23", new Date()),
          beginUpdateTime: dateFormat("YYYY-mm-dd 00", new Date()), //创建时间-开始
          endUpdateTime: dateFormat("YYYY-mm-dd 23", new Date()),
          orderStatus: "", //订单状态
            source: "",
            uid: "",
          isVip: "",
        },
        title: "",
        formLabelWidth: "150px",
        tableData: [],
          sumAmount: 0,
          totalTimes: 0,
        currentPage: 1,
        pageSize: 40,
        total: 0, //总数量
        orderByDescColumn: "", // 降序字段
        orderByAscColumn: "", // 升序字段
        dialogFormVisible: false, //控制弹出框
        form: {
          remarks: "",
        },
        rules: {
          remarks: [
            {required: true, message: '备注不能为空', trigger: 'blur'},
          ],
        }
      };
    },

    created() {
      this.orderWithRequestList();
      this.sourceList();
    },
    methods: {
      sourceList: function() {
        var sourceParams = {};
        sourceParams.pageSize = 1000;
        sourceParams.currentPage = 1;
        getSourceList(sourceParams).then(response => {
          this.sourceData.push(...response.data.records);
        });
      },
      orderWithRequestList: function() {
        this.queryParams.currentPage = this.currentPage;
        this.queryParams.pageSize = this.pageSize;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getWithdrawalList(this.queryParams).then(response => {
          this.tableData = response.data.records;
          this.currentPage = response.data.current;
          this.pageSize = response.data.size;
          this.total = response.data.total;
        });
          getWithdrawalTotal(this.queryParams).then(response =>{
              this.sumAmount = response.data.sumAmount;
              this.totalTimes = response.data.totalTimes;
          });
      },
      getFormObject: function() {
        var formObject = {
          uid: null,
          content: null,
          clickCount: 0,
          sort: 0
        };
        return formObject;
      },

      handleFind: function() {
        this.currentPage = 1
        this.orderWithRequestList();
      },
      handleSizeChange(val) {
        this.pageSize = val;
        this.orderWithRequestList();
      },
      handleCurrentChange: function(val) {
        this.currentPage = val;
        this.orderWithRequestList();
      },
      handleSelectionChange(val) {
        this.multipleSelection = val;
      },
      handleClose(){
        this.dialogFormVisible = false;
        this.orderWithRequestList();
      },
      sortHandleClose(){
        this.dialogFormVisible = false;
        this.$refs.form.clearValidate();
        this.orderWithRequestList();
      },
      //点击编辑
      handleEdit: function(row) {
        this.dialogFormVisible=true;
        this.title = "编辑备注"
        this.form = row;
      },
      handleAdd: function(row) {
        this.dialogFormVisible=true;
        this.title = "新增备注"
        this.form = row;
      },
      // 导出excel数据
      exportData() {
        // 表头对应关系
        const headers = {
          '提现订单号': 'requestId',
          '提现申请时间': 'createTime',
          '用户ID': 'openId',
          '瓦力ID': 'cusUid',
          '会员状态': 'isVip',
          '用户来源': 'sourceName',
          '用户昵称': 'loginName',
          '提现金额': 'amount',
          '提现金额(已扣手续费)': 'taxAmount',
          '操作人员': 'admin',
          '状态异动时间': 'updateTime',
          '状态': 'flag',
          '拒绝理由': 'remarks',
        }
        this.queryParams.currentPage = 1;
        this.queryParams.pageSize = -1;
        this.queryParams.orderByDescColumn = this.orderByDescColumn
        this.queryParams.orderByAscColumn = this.orderByAscColumn
        getWithdrawalList(this.queryParams).then(response => {
          const data = this.formatJson(headers, response.data.records)
          export_json_to_excel(Object.keys(headers), data, '提现审核列表')
        });
      },
      // 该方法负责将数组转化成二维数组
      formatJson(headers, rows) {
        // 首先遍历数组
        return rows.map(item => {
          return Object.keys(headers).map(key => {
            if (headers[key] === 'flag') {
              if(item[headers[key]] === 0){
                return '待审批';
              } else if(item[headers[key]] === 1) {
                return '审批通过';
              } else if(item[headers[key]] === 2){
                return '打款成功';
              }else if(item[headers[key]] ===3){
                return '审批拒绝';
              }
            }else if((headers[key] === 'admin')){
              return 'admin';
            }else if((headers[key] === 'isVip')){
              if(item[headers[key]] ===1){
                return '会员';
              }else{
                return '非会员';
              }
            }
            return item[headers[key]]
          })
        })
      },
      submitForm: function() {
        this.$refs.form.validate((valid) => {
          if(!valid) {
            console.log("校验出错")
          } else {
            editWithdrawalInfo(this.form).then(response => {
                this.$commonUtil.message.success(response.data)
                this.dialogFormVisible = false;
                this.orderWithRequestList();
              });
          }
        })
      },
    }
  };
</script>

<style scoped>

</style>
